struct Threshold{T_Mesh<:Mesh} <: AbstractTCI
  mesh::T_Mesh
  # parameters
  threshold::Float64
end


function compute_indicator!(
    flag, # mutated outputs
    u,    # inputs
    tci::Threshold{<:Mesh1d})

  @unpack mesh, threshold = tci
  L       = layout(mesh)
  Npts, K = L

  fill!(flag, 0)
  u = reshape(u, L)

  for k = 1:K
    for j = 1:Npts
    ujk = u[j,k]
      if ujk >= threshold
        flag[k] = 1
        break
      end
    end
  end

  return
end


function compute_indicator!(
    flag, # mutated outputs
    u,    # inputs
    tci::Threshold{<:Mesh2d})

  @unpack mesh, threshold = tci
  @unpack Npts = mesh.element
  NN = Npts^2

  fill!(flag, 0)

  for (k,o) in enumerate(mesh.offsets)
    for ui in view(u,o+1:o+NN)
      if ui >= threshold
        flag[k] = 1
      end
    end
  end

  return
end
